VanillaSwap Class Reference
Financial instruments

Plain-vanilla swap: fix vs floating leg. More...

`#include <ql/instruments/vanillaswap.hpp>`

Inheritance diagram for VanillaSwap:
[legend]

## Classes

class | arguments
| Arguments for simple swap calculation More...
class | results
| Results from simple swap calculation More...

## Public Types

enum | Type { Receiver = -1, Payer = 1 }

## Public Member Functions

| VanillaSwap (Type type, Real nominal, const Schedule &fixedSchedule, Rate fixedRate, const DayCounter &fixedDayCount, const Schedule &floatSchedule, const boost::shared_ptr< IborIndex > &iborIndex, Spread spread, const DayCounter &floatingDayCount, boost::optional< BusinessDayConvention > paymentConvention=boost::none)
void | setupArguments (PricingEngine::arguments *args) const
void | fetchResults (const PricingEngine::results *) const
Inspectors
Type | type () const
Real | nominal () const
const Schedule & | fixedSchedule () const
Rate | fixedRate () const
const DayCounter & | fixedDayCount () const
const Schedule & | floatingSchedule () const
const boost::shared_ptr< IborIndex > & | iborIndex () const
Spread | spread () const
const DayCounter & | floatingDayCount () const
BusinessDayConvention | paymentConvention () const
const Leg & | fixedLeg () const
const Leg & | floatingLeg () const
Results
Real | fixedLegBPS () const
Real | fixedLegNPV () const
Rate | fairRate () const
Real | floatingLegBPS () const
Real | floatingLegNPV () const
Spread | fairSpread () const
Public Member Functions inherited from Swap
Date | startDate () const
Date | maturityDate () const
Real | legBPS (Size j) const
Real | legNPV (Size j) const
DiscountFactor | startDiscounts (Size j) const
DiscountFactor | endDiscounts (Size j) const
DiscountFactor | npvDateDiscount () const
const Leg & | leg (Size j) const
| Swap (const Leg &firstLeg, const Leg &secondLeg)
| Swap (const std::vector< Leg > &legs, const std::vector< bool > &payer)
bool | isExpired () const
| returns whether the instrument might have value greater than zero.
Public Member Functions inherited from Instrument
Real | NPV () const
| returns the net present value of the instrument.
Real | errorEstimate () const
| returns the error estimate on the NPV when available.
const Date & | valuationDate () const
| returns the date the net present value refers to.
template<typename T >
T | result (const std::string &tag) const
| returns any additional result returned by the pricing engine.
const std::map< std::string, boost::any > & | additionalResults () const
| returns all additional result returned by the pricing engine.
void | setPricingEngine (const boost::shared_ptr< PricingEngine > &)
| set the pricing engine to be used. More...
Public Member Functions inherited from LazyObject
void | update ()
void | recalculate ()
void | freeze ()
void | unfreeze ()
Public Member Functions inherited from Observable
| Observable (const Observable &)
Observable & | operator= (const Observable &)
void | notifyObservers ()
Public Member Functions inherited from Observer
| Observer (const Observer &)
Observer & | operator= (const Observer &)
std::pair< std::set< boost::shared_ptr< Observable > >::iterator, bool > | registerWith (const boost::shared_ptr< Observable > &)
void | registerWithObservables (const boost::shared_ptr< Observer > &)
Size | unregisterWith (const boost::shared_ptr< Observable > &)
void | unregisterWithAll ()

## Additional Inherited Members

Protected Member Functions inherited from Swap
| Swap (Size legs)
Protected Member Functions inherited from Instrument
void | calculate () const
virtual void | performCalculations () const
Protected Member Functions inherited from LazyObject
Protected Attributes inherited from Swap
std::vector< Leg > | legs_
std::vector< Real > | payer_
std::vector< Real > | legNPV_
std::vector< Real > | legBPS_
std::vector< DiscountFactor > | startDiscounts_
std::vector< DiscountFactor > | endDiscounts_
DiscountFactor | npvDateDiscount_
Protected Attributes inherited from Instrument
boost::shared_ptr< PricingEngine > | engine_
Real | NPV_
Real | errorEstimate_
Date | valuationDate_
std::map< std::string, boost::any > | additionalResults_
Protected Attributes inherited from LazyObject
bool | calculated_
bool | frozen_

## Detailed Description

Plain-vanilla swap: fix vs floating leg.

If no payment convention is passed, the convention of the floating-rate schedule is used.

Warning:
  if `Settings::includeReferenceDateCashFlows()` is set to `true`, payments occurring at the settlement date of the swap might be included in the NPV and therefore affect the fair-rate and fair-spread calculation. This might not be what you want.

Tests:
  - the correctness of the returned value is tested by checking that the price of a swap paying the fair fixed rate is null.
  - the correctness of the returned value is tested by checking that the price of a swap receiving the fair floating-rate spread is null.
  - the correctness of the returned value is tested by checking that the price of a swap decreases with the paid fixed rate.
  - the correctness of the returned value is tested by checking that the price of a swap increases with the received floating-rate spread.
  - the correctness of the returned value is tested by checking it against a known good value.

Examples:
  BermudanSwaption.cpp, and swapvaluation.cpp.

## Member Function Documentation

void setupArguments | ( | PricingEngine::arguments * |  | ) | const

virtual

When a derived argument structure is defined for an instrument, this method should be overridden to fill it. This is mandatory in case a pricing engine is used.

Reimplemented from Swap.

void fetchResults | ( | const PricingEngine::results * | r | ) | const

virtual

When a derived result structure is defined for an instrument, this method should be overridden to read from it. This is mandatory in case a pricing engine is used.

Reimplemented from Swap.